## dustrac 2.1.1

=== CMakeLists.txt ===
project(DustRacing2D)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

# Use cmake --help-policy [POLICY] for more information about these:

if(POLICY CMP0005)
    cmake_policy(SET CMP0005 NEW)
endif()

if(POLICY CMP0020)
    cmake_policy(SET CMP0020 NEW)
endif()

# Default to GLVND
if(POLICY CMP0072)
    cmake_policy(SET CMP0072 OLD)
endif()

if(POLICY CMP0043)
    cmake_policy(SET CMP0043 NEW)
endif()

# Global game version
set(VERSION_MAJOR 2)
set(VERSION_MINOR 1)
set(VERSION_PATCH 1)
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

# Some common CPack variables
set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})

set(CPACK_PACKAGE_NAME dustracing2d)
set(CPACK_PACKAGE_VENDOR Juzzlin)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "")
set(CPACK_PACKAGE_ICON ${CMAKE_SOURCE_DIR}/data/images/about.png)

set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/COPYING)
set(CPACK_RESOURCE_FILE_README ${CMAKE_SOURCE_DIR}/README.md)

option(ReleaseBuild "This should be used when creating a build with install targets" OFF)

option(VorbisLibsPath "Optional path hint for vorbis libs (libvorbis, libvorbisfile)." "")

option(OggLibPath "Optional path hint for ogg lib (libogg)." "")

option(DATA_PATH "Optional DATA_PATH for Linux release build." "")

option(BIN_PATH "Optional BIN_PATH for Linux release build." "")

option(DOC_PATH "Optional DOC_PATH for Linux release build." "")

option(GLES "Build for OpenGL ES 2.0" OFF)

option(NO_GLEW "Don't use GLEW to resolve OpenGL extensions if enabled." ON)

option(QOpenGLFunctions "Use QOpenGLFunctions to resolve OpenGL extensions if enabled." ON)

option(UnlockAllTracks "Unlock all tracks (for development purposes)" OFF)

option(SystemFonts "Assume all the fonts are available in the system." OFF)

# Default to release C++ flags if CMAKE_BUILD_TYPE not set
if( NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING
       "Choose the type of build, options are: None Debug Release RelWithDebInfo
MinSizeRel."
       FORCE )
endif()

if(GLES)
    add_definitions(-D__MC_GLES__)
    message(STATUS "Compiling for OpenGL ES 2.0")
else()
    message(STATUS "Compiling for OpenGL 2.1")
endif()

if(NO_GLEW)
    add_definitions(-D__MC_NO_GLEW__)
endif()

if(QOpenGLFunctions)
    message(STATUS "Using QOpenGLFunctions")
    add_definitions(-D__MC_QOPENGLFUNCTIONS__)
    add_definitions(-D__MC_NO_GLEW__)
endif()

if (UnlockAllTracks)
    message(STATUS "All tracks unlocked")
    add_definitions(-DUNLOCK_ALL_TRACKS)
endif()

if(SystemFonts)
    message(STATUS "Assuming system fonts")
    add_definitions(-DSYSTEM_FONTS)
endif()

add_definitions(-DGLEW_STATIC)
add_definitions(-DGLEW_NO_GLU)

if(UNIX)
    include("InstallLinux.cmake")
elseif(WIN32)
    include("InstallWindows.cmake")
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    add_compile_options("$<$<CONFIG:RELEASE>:-W;-Wall;-O3;-pedantic;-fomit-frame-pointer>")
    add_compile_options("$<$<CONFIG:DEBUG>:-W;-Wall;-O0;-pedantic>")

    # Automatically use ccache if found
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif(CCACHE_FOUND)

elseif(MSVC)
    add_definitions(-DNOMINMAX)
endif()

set(GAME_BINARY_NAME "dustrac-game")
set(EDITOR_BINARY_NAME "dustrac-editor")

add_definitions(-DVERSION="${VERSION}")

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(QT_MIN_VER 5.4.0)
find_package(Qt5Core ${QT_MIN_VER} REQUIRED)
find_package(Qt5OpenGL ${QT_MIN_VER} REQUIRED)
find_package(Qt5Xml ${QT_MIN_VER} REQUIRED)
find_package(Qt5Widgets ${QT_MIN_VER} REQUIRED)
find_package(Qt5LinguistTools ${QT_MIN_VER} REQUIRED)
find_package(Qt5Sql ${QT_MIN_VER} REQUIRED)
find_package(Qt5Test ${QT_MIN_VER} REQUIRED)

# Find OpenGL
find_package(OpenGL REQUIRED)
if(${CMAKE_VERSION} VERSION_LESS "3.11.0")
    set(DUSTRAC_OPENGL_LIBS ${OPENGL_gl_LIBRARY})
else()
    set(DUSTRAC_OPENGL_LIBS OpenGL::GL)
endif()

# OpenAL for sounds. OpenAL directory can be given by -DOPENALDIR=...
set(ENV{OPENALDIR} ${OpenALDir})
find_package(OpenAL REQUIRED)
include_directories(${OPENAL_INCLUDE_DIR}/..)

# Vorbis libs for reading Ogg files
if(MSVC)
    find_library(VORBISFILE_LIB NAMES libvorbisfile.a libvorbisfile_static.lib HINTS ${VorbisLibsPath} REQUIRED)
    find_library(VORBIS_LIB NAMES libvorbis.a libvorbis_static.lib HINTS ${VorbisLibsPath} REQUIRED)
    include_directories(${VorbisLibsPath}/include)
    find_library(OGG_LIB NAMES libogg.a libogg_static.lib HINTS ${OggLibPath} REQUIRED)
    include_directories(${OggLibPath}/include)
    message(STATUS "Using static versions of vorbis libs:")
    message(STATUS "  ${VORBISFILE_LIB}")
    message(STATUS "  ${VORBIS_LIB}")
    message(STATUS "  ${OGG_LIB}")
else()
    include(FindPkgConfig)
    pkg_check_modules(VORBISFILE REQUIRED vorbisfile)
endif()

add_subdirectory(src/contrib/SimpleLogger EXCLUDE_FROM_ALL)
include_directories(src/contrib/SimpleLogger/src)

add_subdirectory(src/contrib/Argengine EXCLUDE_FROM_ALL)
include_directories(src/contrib/Argengine/src)

# Enable CMake's unit test framework
enable_testing()

# Install paths depend on the build type and target platform
resolve_install_paths()

add_subdirectory(src/editor)
add_subdirectory(src/game)

=== src/editor/CMakeLists.txt ===
# Translation files in src/editor/translations (without .ts)
set(TS dustrac-editor_fi dustrac-editor_it dustrac-editor_cs dustrac-editor_fr dustrac-editor_de dustrac-editor_ru 
dustrac-editor_nl dustrac-editor_tr)
set(TS_FILES)
set(QM_FILES)
foreach(TS_FILE ${TS})
    list(APPEND TS_FILES ${CMAKE_SOURCE_DIR}/src/editor/translations/${TS_FILE}.ts)
    list(APPEND QM_FILES ${CMAKE_BINARY_DIR}/data/translations/${TS_FILE}.qm)
endforeach()
set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION ${CMAKE_BINARY_DIR}/data/translations)

# Set sources
set(SRC
    aboutdlg.cpp
    application.cpp
    draganddropstore.cpp
    editordata.cpp
    editorview.cpp
    editormode.hpp
    floodfill.cpp
    main.cpp
    mainwindow.cpp
    map.cpp
    mediator.cpp
    newtrackdialog.cpp
    object.cpp
    objectfactory.cpp
    objectmodelloader.cpp
    rotatedialog.cpp
    targetnode.cpp
    targetnodesizedlg.cpp
    tileanimator.cpp
    trackdata.cpp
    trackio.cpp
    tracktile.cpp
    trackpropertiesdialog.cpp
    undostack.cpp
    ../common/config.hpp
    ../common/mapbase.cpp
    ../common/objectbase.cpp
    ../common/objects.cpp
    ../common/route.cpp
    ../common/targetnodebase.cpp
    ../common/trackdatabase.cpp
    ../common/tracktilebase.cpp)

set(RCS ${CMAKE_SOURCE_DIR}/data/images/editor.qrc ${CMAKE_SOURCE_DIR}/data/icons/icons.qrc)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../common)

qt5_add_resources(RC_SRC ${RCS})
qt5_add_translation(QM ${TS_FILES})
qt5_wrap_ui(UI_HDRS ${UIS})

# We need this to be able to include headers produced by uic in our code
include_directories(${CMAKE_BINARY_DIR})

# Resource compilation for MinGW
if(MINGW)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o
        COMMAND
            ${CMAKE_RC_COMPILER}
            -I${CMAKE_SOURCE_DIR} -i${CMAKE_SOURCE_DIR}/data/icons/WindowsEditor.rc
            -o ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o)
    set(SRC ${SRC} ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o)
endif()

# Copy desktop file
if(ReleaseBuild AND UNIX)
    set(DesktopFileSourcePath)
    if(USC)
        set(DesktopFileSourcePath ${CMAKE_SOURCE_DIR}/src/dustrac-editor.desktop.opt.in)
    else()
        set(DesktopFileSourcePath ${CMAKE_SOURCE_DIR}/src/dustrac-editor.desktop.in)
    endif()
    add_custom_target(desktop-file-editor ALL
        COMMAND cmake -E copy ${DesktopFileSourcePath}
            ${CMAKE_BINARY_DIR}/dustrac-editor.desktop
    DEPENDS ${EDITOR_BINARY_NAME})
endif()

# Add the executable
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
add_executable(${EDITOR_BINARY_NAME} WIN32 ${SRC} ${MOC_SRC} ${RC_SRC} ${UI_HDRS} ${QM})

target_link_libraries(${EDITOR_BINARY_NAME} Qt5::Widgets Qt5::Xml Argengine_static)
set_property(TARGET ${EDITOR_BINARY_NAME} PROPERTY CXX_STANDARD 14)

=== src/game/CMakeLists.txt ===
# Sub build: MiniCore engine
add_subdirectory(MiniCore)

# Sub build: Menu Toolkit From Hell
add_subdirectory(MTFH)

# Sub build: Sound Toolkit From Hell
add_subdirectory(STFH)

# Engine include paths
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Asset")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Core")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Graphics")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Particles")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Physics")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MiniCore/src/Text")

# Menu toolkit and menu include paths
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/MTFH")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/menu")

# Sound toolkit include paths
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/STFH")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/audio")

# Translation files in src/game/translations (without .ts)
set(TS dustrac-game_fi dustrac-game_it dustrac-game_cs dustrac-game_fr dustrac-game_de dustrac-game_ru dustrac-game_nl dustrac-game_tr)
set(TS_FILES)
set(QM_FILES)
foreach(TS_FILE ${TS})
    list(APPEND TS_FILES ${CMAKE_SOURCE_DIR}/src/game/translations/${TS_FILE}.ts)
    list(APPEND QM_FILES ${CMAKE_BINARY_DIR}/data/translations/${TS_FILE}.qm)
endforeach()
set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION ${CMAKE_BINARY_DIR}/data/translations)

# Set headers that don't have a corresponding cpp file
set(HDR
    layers.hpp
    shaders.h
    shaders30.h
    ../common/userexception.hpp
)

# Set sources
set(SRC
    ai.cpp
    application.cpp
    bridge.cpp
    car.cpp
    carfactory.cpp
    carparticleeffectmanager.cpp
    carphysicscomponent.cpp
    carsoundeffectmanager.cpp
    carstatusview.cpp
    checkeredflag.cpp
    crashoverlay.cpp
    database.cpp
    difficultyprofile.cpp
    eventhandler.cpp
    fadeanimation.cpp
    fontfactory.cpp
    game.cpp
    gearbox.cpp
    graphicsfactory.cpp
    inputhandler.cpp
    intro.cpp
    main.cpp
    map.cpp
    messageoverlay.cpp
    minimap.cpp
    particlefactory.cpp
    pit.cpp
    offtrackdetector.cpp
    overlaybase.cpp
    race.cpp
    renderer.cpp
    scene.cpp
    settings.cpp
    startlights.cpp
    startlightsoverlay.cpp
    statemachine.cpp
    timing.cpp
    timingoverlay.cpp
    tire.cpp
    track.cpp
    trackdata.cpp
    trackloader.cpp
    trackobject.cpp
    trackobjectfactory.cpp
    tracktile.cpp
    tree.cpp
    ../common/config.hpp
    ../common/datakeywords.hpp
    ../common/objectbase.cpp
    ../common/objects.cpp
    ../common/route.cpp
    ../common/targetnodebase.cpp
    ../common/trackdatabase.cpp
    ../common/tracktilebase.cpp
    ../common/mapbase.cpp
    audio/audioworker.cpp
    audio/audiosource.cpp
    audio/openaldata.cpp
    audio/openaldevice.cpp
    audio/openalsource.cpp
    audio/openaloggdata.cpp
    audio/openalwavdata.cpp
    menu/confirmationmenu.cpp
    menu/credits.cpp
    menu/difficultymenu.cpp
    menu/help.cpp
    menu/keyconfigmenu.cpp
    menu/lapcountmenu.cpp
    menu/mainmenu.cpp
    menu/resolutionmenu.cpp
    menu/settingsmenu.cpp
    menu/surfacemenu.cpp
    menu/textmenuitemview.cpp
    menu/trackselectionmenu.cpp
    menu/vsyncmenu.cpp
    )

set(RCS ${CMAKE_SOURCE_DIR}/data/icons/icons.qrc)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

qt5_add_resources(RC_SRC ${RCS})
qt5_add_translation(QM ${TS_FILES})

# Copy desktop file
if(ReleaseBuild AND UNIX)
    set(DesktopFileSourcePath)
    if(USC)
        set(DesktopFileSourcePath ${CMAKE_SOURCE_DIR}/src/dustrac-game.desktop.opt.in)
    else()
        set(DesktopFileSourcePath ${CMAKE_SOURCE_DIR}/src/dustrac-game.desktop.in)
    endif()
    add_custom_target(desktop-file-game ALL
        COMMAND cmake -E copy ${DesktopFileSourcePath}
            ${CMAKE_BINARY_DIR}/dustrac-game.desktop
    DEPENDS ${GAME_BINARY_NAME})
endif()

# Resource compilation for MinGW
if(MINGW)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o
        COMMAND
            ${CMAKE_RC_COMPILER}
            -I${CMAKE_SOURCE_DIR} -i${CMAKE_SOURCE_DIR}/data/icons/WindowsGame.rc
            -o ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o)
    set(SRC ${SRC} ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o)
endif()

# The main game executable
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
add_executable(${GAME_BINARY_NAME} WIN32 ${HDR} ${SRC} ${MOC_SRC} ${RC_SRC} ${QM})

set(COMMON_LIBS
    MiniCore
    MTFH
    STFH
    ${OPENAL_LIBRARY}
    ${VORBISFILE_LIBRARIES}
    ${VORBISFILE_LIB} # Valid only with MSVC
    ${VORBIS_LIB}     # Valid only with MSVC
    ${OGG_LIB})       # Valid only with MSVC

target_link_libraries(${GAME_BINARY_NAME} ${COMMON_LIBS} Qt5::OpenGL Qt5::Sql Qt5::Xml ${DUSTRAC_OPENGL_LIBS} SimpleLogger_static Argengine_static)
set_property(TARGET ${GAME_BINARY_NAME} PROPERTY CXX_STANDARD 14)

add_subdirectory(unittests)

=== src/contrib/Argengine/CMakeLists.txt ===
project(Argengine)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

option(BUILD_TESTS "Build unit tests" OFF)

option(BUILD_EXAMPLES "Build example apps" OFF)

# Default to release C++ flags if CMAKE_BUILD_TYPE not set
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo
MinSizeRel." FORCE)
endif()

set(CMAKE_CXX_STANDARD 11)

if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic")

    # CMAKE_CXX_STANDARD supported only by versions >= 3.1
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
    endif ()
endif()

set(LIBRARY_NAME "Argengine")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(src/tests)
endif()

add_subdirectory(src)

=== src/contrib/SimpleLogger/CMakeLists.txt ===
project(SimpleLogger)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

option(BUILD_TESTS "Build unit tests" OFF)

# Default to release C++ flags if CMAKE_BUILD_TYPE not set
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo
MinSizeRel." FORCE)
endif()

set(CMAKE_CXX_STANDARD 11)

if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")

    # CMAKE_CXX_STANDARD supported only by versions >= 3.1
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
    endif ()
endif()

set(LIBRARY_NAME "SimpleLogger")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(src/tests)
endif()

add_subdirectory(src)

=== src/game/MTFH/CMakeLists.txt ===
project(MTFH)

include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

set(MTFHSRC
    animationcurve.cpp
    menu.cpp
    menuitem.cpp
    menuitemaction.cpp
    menumanager.cpp
    menuitemview.cpp)

add_library(MTFH ${MTFHSRC})
set_property(TARGET MTFH PROPERTY CXX_STANDARD 11)

=== src/game/MiniCore/CMakeLists.txt ===
project(MiniCore)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

if(POLICY CMP0005)
    cmake_policy(SET CMP0005 NEW)
endif()

if(POLICY CMP0020)
    cmake_policy(SET CMP0020 NEW)
endif()

if(POLICY CMP0043)
    cmake_policy(SET CMP0043 NEW)
endif()

if(POLICY CMP0054)
    cmake_policy(SET CMP0054 NEW)
endif()

option(GLES "Build for OpenGL ES 2.0" OFF)

option(NO_GLEW "Don't use GLEW to resolve OpenGL extensions if enabled." ON)

option(QOpenGLFunctions "Use QOpenGLFunctions to resolve OpenGL extensions if enabled." ON)

if(GLES)
    add_definitions(-D__MC_GLES__)
    message(STATUS "Compiling for OpenGL ES 2.0")
else()
    message(STATUS "Compiling for OpenGL 2.1")
endif()

if(NO_GLEW)
    add_definitions(-D__MC_NO_GLEW__)
endif()

if(QOpenGLFunctions)
    message(STATUS "Using QOpenGLFunctions")
    add_definitions(-D__MC_QOPENGLFUNCTIONS__)
    add_definitions(-D__MC_NO_GLEW__)
endif()

add_definitions(-DGLEW_STATIC)
add_definitions(-DGLEW_NO_GLU)

add_definitions(-DVERSION="${VERSION}")

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(QT_MIN_VER 5.2.1)
find_package(Qt5Core ${QT_MIN_VER} REQUIRED)
find_package(Qt5OpenGL ${QT_MIN_VER} REQUIRED)
find_package(Qt5Xml ${QT_MIN_VER} REQUIRED)
find_package(Qt5Widgets ${QT_MIN_VER} REQUIRED)

# Find OpenGL
find_package(OpenGL REQUIRED)
if(${CMAKE_VERSION} VERSION_LESS "3.11.0")
    set(MINICORE_OPENGL_LIBS ${OPENGL_gl_LIBRARY})
else()
    set(MINICORE_OPENGL_LIBS OpenGL::GL)
endif()

# Enable CMake's unit test framework
enable_testing()

add_subdirectory(src)

=== src/game/STFH/CMakeLists.txt ===
project(STFH)

include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

set(STFHSRC
    data.cpp
    device.cpp
    listener.cpp
    location.cpp
    source.cpp
)

add_library(STFH ${STFHSRC})
set_property(TARGET STFH PROPERTY CXX_STANDARD 11)

=== src/game/unittests/CMakeLists.txt ===
add_subdirectory(gearboxtest)

=== src/contrib/Argengine/src/CMakeLists.txt ===
set(SRC argengine.cpp)
set(HDR argengine.hpp)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_library(ArgengineLib OBJECT ${SRC})
set_property(TARGET ArgengineLib PROPERTY POSITION_INDEPENDENT_CODE 1)

set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})

add_library(${LIBRARY_NAME} SHARED $<TARGET_OBJECTS:ArgengineLib>)
set_target_properties(${LIBRARY_NAME} PROPERTIES PUBLIC_HEADER ${HDR})
install(TARGETS ${LIBRARY_NAME}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    PUBLIC_HEADER DESTINATION include
)

set(STATIC_LIBRARY_NAME ${LIBRARY_NAME}_static)
add_library(${STATIC_LIBRARY_NAME} STATIC $<TARGET_OBJECTS:ArgengineLib>)
set_target_properties(${STATIC_LIBRARY_NAME} PROPERTIES PUBLIC_HEADER ${HDR})
install(TARGETS ${STATIC_LIBRARY_NAME}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    PUBLIC_HEADER DESTINATION include
)

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

=== src/contrib/SimpleLogger/src/CMakeLists.txt ===
set(SRC simple_logger.cpp)
set(HDR simple_logger.hpp)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_library(SimpleLoggerLib OBJECT ${SRC})
set_property(TARGET SimpleLoggerLib PROPERTY POSITION_INDEPENDENT_CODE 1)

set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})

add_library(${LIBRARY_NAME} SHARED $<TARGET_OBJECTS:SimpleLoggerLib>)
set_target_properties(${LIBRARY_NAME} PROPERTIES PUBLIC_HEADER ${HDR})
install(TARGETS ${LIBRARY_NAME}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    PUBLIC_HEADER DESTINATION include
)

set(STATIC_LIBRARY_NAME ${LIBRARY_NAME}_static)
add_library(${STATIC_LIBRARY_NAME} STATIC $<TARGET_OBJECTS:SimpleLoggerLib>)
set_target_properties(${STATIC_LIBRARY_NAME} PROPERTIES PUBLIC_HEADER ${HDR})
install(TARGETS ${STATIC_LIBRARY_NAME}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    PUBLIC_HEADER DESTINATION include
)

=== src/game/MiniCore/src/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/Asset")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/Core")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/Graphics")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/Physics")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/Text")

set(MiniCoreSRC
Asset/mcassetmanager.cc
Asset/mcmeshconfigloader.cc
Asset/mcmeshloader.cc
Asset/mcmeshmanager.cc
Asset/mcmeshobjectdata.cc
Asset/mcsurfaceobjectdata.cc
Asset/mcsurfaceconfigloader.cc
Asset/mcsurfacemanager.cc
Core/mcbbox.hh
Core/mcbbox3d.hh
Core/mcevent.cc
Core/mclogger.cc
Core/mcmathutil.cc
Core/mcmacros.hh
Core/mcobbox.hh
Core/mcobject.cc
Core/mcobjectcomponent.cc
Core/mcobjectdata.cc
Core/mcobjectfactory.cc
Core/mcrandom.cc
Core/mctimerevent.cc
Core/mctrigonom.cc
Core/mctyperegistry.cc
Core/mcvectoranimation.cc
Core/mcvector2d.hh
Core/mcvector3d.hh
Core/mcworld.cc
Graphics/mccamera.cc
Graphics/mcglambientlight.cc
Graphics/mcgldiffuselight.cc
Graphics/mcglmaterial.cc
Graphics/mcglobjectbase.cc
Graphics/mcglscene.cc
Graphics/mcglshaderprogram.cc
Graphics/mcmesh.cc
Graphics/mcmeshview.cc
Graphics/mcobjectrendererbase.cc
Graphics/mcparticle.cc
Graphics/mcparticlerendererbase.cc
Graphics/mcrenderlayer.cc
Graphics/mcshaders.hh
Graphics/mcshaders30.hh
Graphics/mcshadersGLES.hh
Graphics/mcshapeview.cc
Graphics/mcsurfaceparticle.cc
Graphics/mcsurfaceobjectrenderer.cc
Graphics/mcsurfaceobjectrendererlegacy.cc
Graphics/mcsurfaceparticlerenderer.cc
Graphics/mcsurfaceparticlerendererlegacy.cc
Graphics/mcsurface.cc
Graphics/mcsurfaceview.cc
Graphics/mcworldrenderer.cc
Physics/mccircleshape.cc
Physics/mccollisiondetector.cc
Physics/mccollisionevent.cc
Physics/mccontact.cc
Physics/mcdragforcegenerator.cc
Physics/mcforcegenerator.cc
Physics/mcforceregistry.cc
Physics/mcfrictiongenerator.cc
Physics/mcgravitygenerator.cc
Physics/mcimpulsegenerator.cc
Physics/mcobjectgrid.cc
Physics/mcoutofboundariesevent.cc
Physics/mcphysicscomponent.cc
Physics/mcrectshape.cc
Physics/mcseparationevent.cc
Physics/mcshape.cc
Physics/mcspringforcegenerator.cc
Physics/mcspringforcegenerator2dfast.cc
Text/mctexturefont.cc
Text/mctexturefontconfigloader.cc
Text/mctexturefontdata.cc
Text/mctexturefontmanager.cc
Text/mctextureglyph.cc
Text/mctexturetext.cc
)

if(NOT QOpenGLFunctions)
set(MiniCoreSRC ${MiniCoreSRC} Graphics/contrib/glew/glew.c)
endif()

set(MiniCoreTargetName MiniCore)
add_library(${MiniCoreTargetName} ${MiniCoreSRC})
target_link_libraries(${MiniCoreTargetName} Qt5::Core Qt5::OpenGL Qt5::Xml ${MINICORE_OPENGL_LIBS})
set_property(TARGET ${MiniCoreTargetName} PROPERTY CXX_STANDARD 14)

add_subdirectory(UnitTests)

=== debian/changelog ===
dustrac (2.1.1-3) unstable; urgency=medium

  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Pass -DCMAKE_POLICY_VERSION_MINIMUM=3.5 to cmake so it builds with cmake 4
    (hoping that everything works properly). (Closes: #1112861)
  * Run xvfb-run with -a to reduce issues.
  * Switch the transitional pkg-config build dependency to pkgconf.

 -- Pino Toscano <pino@debian.org>  Tue, 07 Oct 2025 00:08:15 +0200

dustrac (2.1.1-2) unstable; urgency=medium

  * Add Vcs-* fields.
  * Add the configuration for the CI on salsa.
  * Mark the xauth, and xvfb build dependencies as <!nocheck>, as they are
    needed only when running the test suite.
  * Bump Standards-Version to 4.6.1, no changes required.

 -- Pino Toscano <pino@debian.org>  Thu, 19 May 2022 10:45:00 +0200

dustrac (2.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Pass -DSystemFonts=ON to cmake to always rely on system fonts
    - drop the replacing of fonts with symlinks to system files
  * Update install files.
  * Stop forcing cmake as buildsystem, as the upstream "configure" script
    (that misled the dh autodetection) was removed.
  * Bump Standards-Version to 4.5.1, no changes required.
  * Drop check for nocheck in $DEB_BUILD_OPTIONS, as debhelper in compatibility
    version 13 already skips it.

 -- Pino Toscano <pino@debian.org>  Mon, 01 Mar 2021 12:36:33 +0100

=== debian/control ===
Source: dustrac
Section: games
Priority: optional
Maintainer: Pino Toscano <pino@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake (>= 3.1),
 pkgconf,
 qtbase5-dev (>= 5.4.0~),
 libqt5opengl5-desktop-dev (>= 5.4.0~),
 qttools5-dev (>= 5.4.0~),
 libopenal-dev,
 libvorbis-dev,
 xauth <!nocheck>,
 xvfb <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://juzzlin.github.io/DustRacing2D/
Vcs-Browser: https://salsa.debian.org/pino/dustrac
Vcs-Git: https://salsa.debian.org/pino/dustrac.git

Package: dustracing2d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 dustracing2d-data (>= ${source:Version}),
 libqt5sql5-sqlite,
Description: tile-based 2D racing game
 Dust Racing (Dustrac) is a tile-based, cross-platform 2D racing game.
 .
 Dust Racing comes with a level editor for easy level creation.
 .
 Features:
  * 1-2 human players against 11 challenging computer players
  * 3 difficulty settings: Easy, Medium, Senna
  * Split-screen two player game (vertical or horizontal)
  * Game modes: Race, Time Trial, Duel
  * 2D graphics with some 3D objects
  * Smooth game play and physics
  * Multiple race tracks
  * Finishing in TOP-6 will unlock the next race track
  * Star ratings based on the best positions on each race track
  * Easy to create new race tracks with the level editor
  * Engine and collision sounds
  * Pit stops
  * Runs windowed or fullscreen

Package: dustracing2d-data
Architecture: all
Depends: ${misc:Depends},
 fonts-dejavu-core,
Description: data files for Dust Racing 2D
 Dust Racing (Dustrac) is a tile-based, cross-platform 2D racing game.
 .
 This package contains the data files for Dust Racing 2D.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
	  -DReleaseBuild=ON \
	  -DSystemFonts=ON \
	  -DBIN_PATH=/usr/games/ \
	  -DDOC_PATH=/usr/share/doc/dustracing2d/ \
	  -DDATA_PATH=/usr/share/games/dustracing2d/

override_dh_auto_test:
	xvfb-run -a dh_auto_test

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%DustRacing2D-$1.tar.gz%" \
https://github.com/juzzlin/DustRacing2D/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## dustrac 2.2.0

=== debian/changelog ===
dustrac (2.2.0-1) unstable; urgency=medium

  * New upstream release:
    - test executables are generated within the build directory
      (Closes: #1044741)
  * Update the build dependencies following the port to Qt 6:
    - remove qtbase5-dev, libqt5opengl5-desktop-dev, and qttools5-dev
      (Closes: #888885)
    - add qt6-base-dev, and qt6-tools-dev
  * Update the other build dependencies according to the upstream build system:
    - bump cmake to 3.10
  * Update copyright.
  * Switch the runtime libqt5sql5-sqlite dependency to libqt6sql6-sqlite.
  * Bump Standards-Version to 4.7.3, no changes required.
  * Stop passing -DCMAKE_POLICY_VERSION_MINIMUM=3.5 to cmake, as the build
    system supports newer cmake versions.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.

 -- Pino Toscano <pino@debian.org>  Sun, 08 Feb 2026 11:44:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,16 @@
 Source: dustrac
 Section: games
-Priority: optional
 Maintainer: Pino Toscano <pino@debian.org>
 Build-Depends: debhelper-compat (= 13),
- cmake (>= 3.1),
+ cmake (>= 3.10~),
  pkgconf,
- qtbase5-dev (>= 5.4.0~),
- libqt5opengl5-desktop-dev (>= 5.4.0~),
- qttools5-dev (>= 5.4.0~),
+ qt6-base-dev (>= 6.4.0~),
+ qt6-tools-dev (>= 6.4.0~),
  libopenal-dev,
  libvorbis-dev,
  xauth <!nocheck>,
  xvfb <!nocheck>,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://juzzlin.github.io/DustRacing2D/
 Vcs-Browser: https://salsa.debian.org/pino/dustrac
 Vcs-Git: https://salsa.debian.org/pino/dustrac.git
@@ -21,7 +19,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
  dustracing2d-data (>= ${source:Version}),
- libqt5sql5-sqlite,
+ libqt6sql6-sqlite,
 Description: tile-based 2D racing game
  Dust Racing (Dustrac) is a tile-based, cross-platform 2D racing game.
  .

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,6 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-	  -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
 	  -DReleaseBuild=ON \
 	  -DSystemFonts=ON \
 	  -DBIN_PATH=/usr/games/ \
